#!/bin/sh

# prepare lib

GROUPNAME=spark
APPBASEDIR=/root/$GROUPNAME
HALMODULESDIR=$APPBASEDIR/modules
APPMODULESDIR=$APPBASEDIR
USRLIBDIR=$APPBASEDIR/lib
USRSCRIPTDIR=$APPBASEDIR/etc
SAMBADIR=$APPBASEDIR/etc/samba

chown -R root.root /root

########### place /tmp to tmpfs ##############
rm -rf /tmp
umount /dev/shm
mount -t tmpfs tmpfs /dev/shm -o size=6m
mkdir /dev/shm/tmp
chmod 1777 /dev/shm/tmp
mkdir /tmp
mount --bind /dev/shm/tmp /tmp
##############################################

find /usr/lib/ -type l -name "lib*" | xargs rm -rf
for file in `ls $USRLIBDIR/lib*`
do
    ln -s $file /usr/lib/${file##*/}
done

cd /lib
ln -s libpcap.so.0.9.8 libpcap.so


###########create GUI lib links###############
ln -s $USRLIBDIR/libfreetype.so.6.3.18 /usr/lib/libfreetype.so.6
ln -s $USRLIBDIR/libfreetype.so.6.3.18 /usr/lib/libfreetype.so
ln -s $USRLIBDIR/libywgui.so.1.0 /usr/lib/libywgui.so.1
ln -s $USRLIBDIR/libywgui.so.1.0 /usr/lib/libywgui.so

ln -sf $USRLIBDIR/libxml2.so.2.7.2 /usr/lib/libxml2.so.2
ln -sf $USRLIBDIR/libxml2.so.2.7.2 /usr/lib/libxml2.so
ln -sf $USRLIBDIR/libwrap.so.0.7.6 /usr/lib/libwrap.so.0
ln -sf $USRLIBDIR/libwrap.so.0.7.6 /usr/lib/libwrap.so
ln -sf $USRLIBDIR/libpcap.so.0.9.8 /usr/lib/libpcap.so

####### library for loadkeys/dumpkeys ########
ln -sf $USRLIBDIR/libcfont.so.0.0.0 /usr/lib/libcfont.so.0      
ln -sf $USRLIBDIR/libctutils.so.0.0.0 /usr/lib/libctutils.so.0
ln -sf $USRLIBDIR/libconsole.so.0.0.0 /usr/lib/libconsole.so.0 
##############################################

############add for opera fonts###############
ln -sf $APPBASEDIR/AppRes/arial.ttf $USRSCRIPTDIR/opera/fonts/arial.ttf
##############################################

#############create sclib links###############
. $USRLIBDIR/sclib/scliblink.sh
##############################################

#####lwj add for root passwd ########
if [ -f $APPBASEDIR/passwd ]
then
    cp $APPBASEDIR/passwd /etc/passwd -f
else
    cp $USRSCRIPTDIR/passwd /etc/passwd
    cp $USRSCRIPTDIR/passwd $APPBASEDIR/passwd
fi
/usr/sbin/telnetd

######lwj add for ftp #####
rm -rf /var
#ln -s $USRSCRIPTDIR/var /var
rm -rf /root/plugin/var/log.nmbd
ln -s /root/plugin/var /var
if [ -d "/var/bin" ]; then
	chmod 755 /var/bin/*
fi

mkdir -p /var/run

rm -rf /var/empty
ln -sf /root/spark/etc/var/empty /var/empty
if [ -d "/var/empty" ]; then
	chmod 711 /var/empty
fi

if [ -d "/var/empty/sshd" ];then
	chmod 711 /var/empty/sshd
fi

ln -sf /root/spark/etc/inadyn.conf /etc/inadyn.conf

/etc/init.d/sshd start
##/etc/init.d/inadyn start
rm -rf /tmp/*

find /etc/ -type l -name "resolv.conf" | xargs rm -rf
ln -s $USRSCRIPTDIR/resolv.conf /etc/resolv.conf
ln -s $USRSCRIPTDIR/directfbrc /etc/directfbrc

ln -s $SAMBADIR/smbd /usr/sbin/smbd
ln -s $SAMBADIR/nmbd /usr/sbin/nmbd
cd /etc
ln -s $SAMBADIR/samba/  samba
if [ -d "/root/tmp" ]; then
	echo "tmp is exist"
	rm -rf /root/tmp/*
else
	mkdir /root/tmp
fi

if [ -d "/storage" ];then
	echo "storage is exist"
else
	mkdir /storage
	chmod 777 /storage
fi

if [ -d "/root/spark/Ad" ];then
	echo "/root/spark/Ad is exist"
else
	mkdir /root/spark/Ad
fi

mkdir -p /lib/firmware
ln -s $HALMODULESDIR/rt73.bin /lib/firmware/rt73.bin
ln -s $USRSCRIPTDIR/Wireless/ /etc/Wireless
ln -s $USRSCRIPTDIR/wpa_supplicant.conf /etc/wpa_supplicant.conf
ln -s $USRSCRIPTDIR/ppp/ /etc/ppp
ln -s $USRSCRIPTDIR/vpn/ /etc/vpn

#################################################################
### add for Opera browser ####
rm -f $APPBASEDIR/run-Opera
rm -f $APPBASEDIR/run-OperaSD
rm -f $APPBASEDIR/directfb-ui
rm -f $APPBASEDIR/run-Corsair
rm -f $APPBASEDIR/run-YouPorn
rm -f $APPBASEDIR/run-Portal
rm -f $APPBASEDIR/run-RSS
ln -sf $USRSCRIPTDIR/opera/run-Opera $APPBASEDIR/run-Opera
ln -sf $USRSCRIPTDIR/opera/run-OperaSD $APPBASEDIR/run-OperaSD
ln -sf $USRSCRIPTDIR/opera/directfb-ui $APPBASEDIR/directfb-ui
ln -sf $USRSCRIPTDIR/opera/run-Corsair $APPBASEDIR/run-Corsair
ln -sf $USRSCRIPTDIR/opera/run-YouPorn $APPBASEDIR/run-YouPorn
ln -sf $USRSCRIPTDIR/opera/run-Portal $APPBASEDIR/run-Portal
ln -sf $USRSCRIPTDIR/opera/run-RSS $APPBASEDIR/run-RSS
################################################################

################################################################
### add for flashplayer
rm -f run-flashplayer
ln -sf $USRSCRIPTDIR/flashplayer/run-flashplayer $APPBASEDIR/run-flashplayer
################################################################

# CREATE SPARK I APP RUNTIME ENV

cd $HALMODULESDIR
if [ -f $APPBASEDIR/ywapp_mini.exe ]
then
	. load_modules_mini.sh
else
	. load_modules.sh
fi

#start minihttpd
cd $USRSCRIPTDIR
#http server already in spark, so remove this.
#./minihttpd/mini_httpd -d "./minihttpd/httpd" -c "cgi-bin/*"
# start vsftp
./vsftpd/vsftpd ./vsftpd/vsftpd.conf &
cp /etc/samba/smbpasswd /tmp
/usr/sbin/smbd -D -s /etc/samba/smb.conf
/usr/sbin/nmbd -D -l /tmp -s /etc/samba/smb.conf

########## place it after resolv.conf ###########
/etc/init.d/inadyn start
#################################################


if [ -d "/root/spark/autotest" ];then
	echo "autotest exist"
else
	mkdir /root/spark/autotest
fi
#echo "mount -o nolock 192.168.0.30:/mnt/stb_auto_test /root/spark/autotest"
#mount -o nolock 192.168.0.30:/mnt/stb_auto_test /root/spark/autotest

#ybk add for portal
#################################################
echo -n > boxinfo.js

stbidfile=/proc/sparkid

if [ -f $stbidfile ]
then
echo -n __spark_stbid__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
cat $stbidfile | grep "stb id" | awk '{print $4}'|sed 's/://'| xargs echo -n >> boxinfo.js
echo "\";" >> boxinfo.js

echo -n __spark_mac_address__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
cat $stbidfile | grep "mac address" | awk '{printf $4}' | xargs echo -n >> boxinfo.js
echo "\";" >> boxinfo.js
echo -n __deviceDRMId__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
echo "\";" >> boxinfo.js

echo -n __DRMType__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
echo -n "loco" >> boxinfo.js
echo "\";" >> boxinfo.js

echo -n __osVersion__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
echo -n "2.6.32.42_stm24_V4.1" >> boxinfo.js
echo "\";" >> boxinfo.js

echo -n __appVersion__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
more /root/spark/Version.xml | grep AppPrg | awk '{print $3}'|awk -F = '{print $2}' | xargs echo -n >> boxinfo.js
echo "\";" >> boxinfo.js

echo -n __deviceInfo__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
echo "\";" >> boxinfo.js

echo -n __protocol__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
echo -n "hls0" >> boxinfo.js
echo "\";" >> boxinfo.js

echo -n __version__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
echo -n "1.0" >> boxinfo.js
echo "\";" >> boxinfo.js

echo -n __deviceGroup__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
echo -n "Linux_STB" >> boxinfo.js
echo "\";" >> boxinfo.js

echo -n __model__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
cat $stbidfile | grep "stb model" | awk '{printf $4}' | xargs echo -n >> boxinfo.js
echo "\";" >> boxinfo.js

echo -n __stb_sn__= >> boxinfo.js
echo -n "\"" >> boxinfo.js
cat $stbidfile | grep "stb sn" | awk '{printf $4}' | xargs echo -n >> boxinfo.js
echo "\";" >> boxinfo.js

mv boxinfo.js /root/spark/etc/opera/opera_dir/userjs/
fi

echo "drm_init_str:locodrm-server.locostream.com" > /root/spark/etc/hlsserver.conf
#################################################
#ybk add for portal end

#################################################
rm -f /usr/local
rm -f /var/log/lighttpd
ln -sf /root/spark/etc/lighttpd /usr/local
mkdir -p /var/log
mkdir -p /var/tmp
ln -sf /root/spark/etc/lighttpd/log /var/log/lighttpd
#/root/spark/etc/lighttpd/sbin/lighttpd -f /root/spark/etc/lighttpd/lighttpd.conf
#sleep 1
#/root/spark/etc/lighttpd/sbin/lighttpd -f /root/spark/etc/lighttpd/lighttpd.conf
#################################################


#################################################
echo 5120 > /proc/sys/vm/min_free_kbytes
#################################################


cd $APPBASEDIR
##########run spark SYSTEM CMD server############
./ywsystem_server.exe &
#################################################

if [ -f ./ywapp_mini.exe ]
then
./ywapp_mini.exe
else
./ywapp.exe
fi
echo "^_^ spark is runnig ^_^"


