(function($) {

	$.key = {
		KEY_PLAY : 80,
		KEY_STOP : 10,
		KEY_PAUSE :66,
		KEY_FULLSCREEN : 48,

		KEY_UP : 38,
		KEY_DOWN : 40,
		KEY_LEFT : 37,
		KEY_RIGHT : 39
	},

	$.status = {
		VIDEO_STOPPED : 0,
		VIDEO_PLAYING : 1,
		VIDEO_PAUSED : 2,
		VIDEO_CONNECTING : 3,
		VIDEO_BUFFERING : 4,
		VIDEO_FINISHED : 5,
		VIDEO_ERROR : 6,
	},

	$.audio = {
		vid : null,
		vidUrl : "",
		statusCallback : null,

		initAudio : function(type, videoUrl)
		{
			var videohtml = "<object id='_audioobj' type='" + type + "' data=''></object>";
			var jVideo = $(videohtml);
			$.mediaPlayer.jMediaContainer.append( jVideo );

			this.vid = jVideo[0];

			this.vid.onPlayStateChange = this.setVideoControlStatus;
			this.setVideoUrl( videoUrl );

			$(document).keydown( this.audioControl );
		},

		audioControl : function(event) {
			switch(event.keyCode){
				case $.key.KEY_PLAY:  
					if($.audio.vid.data == "")
					{
						$.audio.vid.data = $.audio.vidUrl ;
					}

					if($.audio.vid.data == "" || $.audio.vid.data == undefined || $.audio.vid.data == null) return;
					$.audio.vid.play(1);
					break;
				case $.key.KEY_STOP:  
					$.audio.vid.stop();  
					break;
				case $.key.KEY_PAUSE: 
					$.audio.vid.play(0);
					break;
				default:
					break;
			}
		},

		setVideoUrl : function( videoUrl )
		{
			if(typeof videoUrl != "undefined" && videoUrl != null && videoUrl != "")
			{
				if(videoUrl != this.vidUrl){ 
					$.audio.vid.data = "";
					$.audio.vid.stop();  
					this.vidUrl = videoUrl;
				}
			}
		},

		setVideoControlStatus : function()
		{
			if($.audio.statusCallback != null) $.audio.statusCallback( $.audio.getPlayState() );
			
			switch($.audio.getPlayState())
			{
				case $.status.VIDEO_PLAYING:
				case $.status.VIDEO_CONNECTING:
				case $.status.VIDEO_BUFFERING:
					break;
				case $.status.VIDEO_FINISHED:
					$.audio.vid.stop();
				case $.status.VIDEO_ERROR:
				case $.status.VIDEO_STOPPED:
				case $.status.VIDEO_PAUSED:
					$.mediaPlayer.jMediaContainer.removeClass('isPlaying');
					break;
				default:
					break;
			}
		},

		///// Get Functions
		getPlayState : function()
		{
			return this.vid.playState ;
		},
		
		getPlayTime : function ()
		{
			return this.vid.playTime ;
		},

		getPlayPosition : function ()
		{
			return this.vid.playPosition ;
		},
	},

	$.video = {
		vid : null,
		vidUrl : "",
		statusCallback : null,
		fullScreen : false,

		initVideo : function(type, videoUrl)
		{
			var videohtml = "<object id='_videoobj' type='" + type + "' data=''></object>";
			var jVideo = $(videohtml);
			$.mediaPlayer.jMediaContainer.append( jVideo );

			this.vid = jVideo[0];
			this.vid.onPlayStateChange = this.setVideoControlStatus;

			this.setVideoUrl( videoUrl );

			$(document).keydown( this.videoControl );
		},

		videoControl : function(event) {

			if( !$.video.testResponse(event.keyCode, $.video.vid.playState) ) return;

			switch(event.keyCode)
			{
				case $.key.KEY_PLAY:  
					if($.video.vid.data == "")
					{
						$.video.vid.data = $.video.vidUrl ;
					}

					if($.video.vid.data == "" || $.video.vid.data == undefined || $.video.vid.data == null) return;
					$.video.vid.play(1);
					break;
				case $.key.KEY_STOP:  
					$.video.vid.stop();  
					break;
				case $.key.KEY_PAUSE: 
					$.video.vid.play(0);
					break;
				case $.key.KEY_FULLSCREEN: 
					$.video.toggleFullScreen(); 
					break;
				case $.key.KEY_UP:
				case $.key.KEY_DOWN:
				case $.key.KEY_LEFT:
				case $.key.KEY_RIGHT:
					$.video.onNavKeyPress( event.keyCode );
					event.preventDefault();
					break;
				default:
					break;
			}

			$.video.afterVideoAction( event.keyCode );
		},

		testResponse : function( keycode, pstate )
		{
			var result = true;

			if(keycode == $.key.KEY_PLAY)
			{
				if(this.vid.playState == $.status.VIDEO_FINISHED || this.vid.playState == $.status.VIDEO_ERROR)
					this.vid.stop();

				result = !( pstate == $.status.VIDEO_PLAYING || pstate == $.status.VIDEO_CONNECTING || pstate == $.status.VIDEO_BUFFERING );
			}

			if( keycode == $.key.KEY_STOP )
				result = !( pstate == $.status.VIDEO_STOPPED || pstate == $.status.VIDEO_FINISHED || pstate == $.status.VIDEO_ERROR );

			if( keycode == $.key.KEY_PAUSE )
				result = ( pstate == $.status.VIDEO_PLAYING );

			return result;
		},

		toggleFullScreen : function()
		{
			$.mediaPlayer.jMediaContainer.toggleClass('fullScreen');
			this.fullScreen = !this.fullScreen;
		},

		setVideoControlStatus : function(){},
		onNavKeyPress : function(keyCode){	alert(keyCode);  },
		afterVideoAction : function(keyCode){	alert(keyCode);  },


		///// Get Functions
		getPlayState : function()
		{
			return this.vid.playState ;
		},
		
		getPlayTime : function ()
		{
			return this.vid.playTime ;
		},

		getPlayPosition : function ()
		{
			return this.vid.playPosition ;
		},

		setVideoUrl : function( videoUrl )
		{
			if(typeof videoUrl != "undefined" && videoUrl != null && videoUrl != "")
			{
				if(videoUrl != this.vidUrl)
				{
					$.video.vid.stop();  
					$.video.vid.data = "";
					this.vidUrl = videoUrl;
				}
			}
		}
	},

	$.videoControlBar = 
	{
		focusDiv : null,
		
		initVideoControlbar : function( flag )
		{
			var barHtml = " <div id='_videoControlBar'>  " +
				"	<div class='fullScreen' tabindex='1'></div>   " +
				"	<div class='play' tabindex='1'></div>  " +
				"	<div class='stop' tabindex='1'></div>  " +
				"	<div id='_progressBarContainer'>  " +
				"		<div style='float:left;' id='_curTime'>00:00</div>  " +
				"		<div style='float:right;' id='_playTime'>00:00</div>  " +
				"		<div class='progress-holder'>  " +
				"			<div class='load-progress'></div>  " +
				"			<div class='play-progress'></div>  " +
				"			<div id='_play-pointer'><img src='/apis/image/process.png'></div>  " +
				"		</div>  " +
				"	</div>  " +
				" </div> ";

			var jBar = $(barHtml);

			$.mediaPlayer.jMediaContainer.append( jBar );

			var parentPadding = (parseInt($.mediaPlayer.jMediaContainer.css("padding-left")) + parseInt($.mediaPlayer.jMediaContainer.css("padding-right")));

			if( parentPadding != 0)
			{
				jBar.css("margin-left",$.mediaPlayer.jMediaContainer.css("padding-left")).css("margin-right",$.mediaPlayer.jMediaContainer.css("padding-right"));
				jBar.css("width", ($.mediaPlayer.jMediaContainer.outerWidth() - parentPadding) + "px");
			}

			var parentPaddingBottom = parseInt($.mediaPlayer.jMediaContainer.css("padding-bottom"));
			if( parentPaddingBottom != 0)
			{
				jBar.css("margin-bottom",parentPaddingBottom + "px");
			}
			
			if( typeof flag == "undefined" || !flag ){
				$.mediaPlayer.jMediaContainer.addClass("barOutside");
				$.video.vid.height = ($.mediaPlayer.jMediaContainer.height() - jBar.outerHeight()) + "px";
			}
			else
			{
				$.video.vid.height = "100%";
			}

			function callVideoControl(jObj)
			{
				var e = new Object();

				if(jObj.attr("class").indexOf("stop") >= 0 )
				{
					e.keyCode = $.key.KEY_STOP;
				}
				else if(jObj.attr("class").indexOf("play") >= 0 )
				{
					e.keyCode = ( $.video.getPlayState() == $.status.VIDEO_PLAYING) ? $.key.KEY_PAUSE : $.key.KEY_PLAY ;
				}
				else if(jObj.attr("class").indexOf("fullScreen") >= 0 )
				{
					e.keyCode = $.key.KEY_FULLSCREEN;
				}

				$.video.videoControl( e );
			}

			$.mediaPlayer.jMediaContainer.find("#_videoControlBar .fullScreen").click( function(){ callVideoControl( $(this) );  } );
			$.mediaPlayer.jMediaContainer.find("#_videoControlBar .stop").click( function(){  callVideoControl( $(this) ); } );
			$.mediaPlayer.jMediaContainer.find("#_videoControlBar .play").click( function(){  callVideoControl( $(this) ); } );
		},

		playTime : 0,
		playPos : 0,
		intervalID : 0,

		getPos : function ()
		{
			function getTime(time)
			{
				if(isNaN(time)) return "00:00";

				var tmp = time/1000;
				var min = Math.floor(tmp/60);
				var sec = Math.round(tmp - min*60);
				return ((min<10)?("0"+min):min) + ":" + ((sec<10)?("0"+sec):sec);
			}
			
			this.playPos  = $.video.getPlayPosition();
			if(isNaN( this.playTime ) == true || this.playTime == 0 || 
					isNaN( this.playPos ) == true || this.playPos == 0 )
			{
				this.playTime = $.video.getPlayTime();
				$.mediaPlayer.jMediaContainer.find("#_videoControlBar #_playTime").text( getTime( this.playTime ) );

				if( $.mediaPlayer.jMediaContainer.find("#_videoControlBar #_playTime").text().length > 5 )
					$.mediaPlayer.jMediaContainer.find("#_videoControlBar .progress-holder").addClass("longTxt");
			}
			$.mediaPlayer.jMediaContainer.find("#_videoControlBar #_curTime").text( getTime( this.playPos ) );
			
			return this.playPos;
		},

		setVideoControlStatus : function()
		{
			if($.video.statusCallback != null)
				$.video.statusCallback( $.video.getPlayState() );
			
			var jPointer = $.mediaPlayer.jMediaContainer.find("#_videoControlBar  #_play-pointer");
			$.videoControlBar.setVisible( true );
			var jProgressHolder = $.mediaPlayer.jMediaContainer.find("#_videoControlBar  .progress-holder");
			
			function drawProgressbar(){
				var progress = Math.round(100*$.videoControlBar.getPos()/$.videoControlBar.playTime);
				if($.videoControlBar.playTime == 0) return;

				if( progress == 100){
					clearInterval($.videoControlBar.intervalID);
					$.videoControlBar.intervalID = 0 ;
				}

				if( 
					((progress < 50) && (jProgressHolder.attr("class").indexOf("afterMiddle") >= 0 )) || 
					( (progress >= 50) &&  (jProgressHolder.attr("class").indexOf("afterMiddle") < 0 ))
				)
				{
					jProgressHolder.toggleClass("afterMiddle");
				}

				jPointer.css("left", progress + "%" );
				$.mediaPlayer.jMediaContainer.find("#_videoControlBar .play-progress")
					.css("width", progress + "%");
			}

			switch($.video.getPlayState())
			{
				case $.status.VIDEO_PLAYING:
					$.videoMessage.setMessage(null);
					$.videoControlBar.setVisible( false );

					if($.videoControlBar.intervalID !=0) break;
					$.videoControlBar.intervalID = setInterval( drawProgressbar, 1000);
				case $.status.VIDEO_CONNECTING:
				case $.status.VIDEO_BUFFERING:
					if( $.videoControlBar.intervalID !=0 ) return;
					$.videoMessage.setMessage("Buffering...");
					break;
				case $.status.VIDEO_FINISHED:
					clearInterval($.videoControlBar.intervalID);
					$.videoControlBar.intervalID = 0;
					$.videoControlBar.playTime = 0;

					$.mediaPlayer.jMediaContainer.removeClass('isPlaying');

					if($.video.fullScreen && $.video.statusCallback != null) $.video.toggleFullScreen();

					break;
				case $.status.VIDEO_ERROR:
					$.videoMessage.setMessage("Video play error!");
					$.mediaPlayer.jMediaContainer.find("#_videoControlBar #_curTime").text('00:00');
					$.mediaPlayer.jMediaContainer.find("#_videoControlBar #_playTime").text('00:00');
					$.mediaPlayer.jMediaContainer.find("#_videoControlBar .play-progress").css("width","0%");
					$.videoControlBar.playTime = 0;

					clearInterval($.videoControlBar.intervalID);
					$.videoControlBar.intervalID = 0 ;
					$.mediaPlayer.jMediaContainer.removeClass('isPlaying');
					$.mediaPlayer.jMediaContainer.find("#_videoControlBar  .progress-holder").removeClass("afterMiddle");

					jPointer.css("left", "0px" );
					break;
				case $.status.VIDEO_STOPPED:
					$.videoMessage.setMessage( null );
					if($.video.fullScreen) $.video.toggleFullScreen();

					$.mediaPlayer.jMediaContainer.find("#_videoControlBar #_curTime").text('00:00');
					$.mediaPlayer.jMediaContainer.find("#_videoControlBar #_playTime").text('00:00');
					$.mediaPlayer.jMediaContainer.find("#_videoControlBar .play-progress").css("width","0%");
					$.videoControlBar.playTime = 0;

					clearInterval($.videoControlBar.intervalID);
					$.videoControlBar.intervalID = 0 ;
					$.mediaPlayer.jMediaContainer.removeClass('isPlaying');
					$.mediaPlayer.jMediaContainer.find("#_videoControlBar  .progress-holder").removeClass("afterMiddle");

					jPointer.css("left",  "0px" );
					break;
				case $.status.VIDEO_PAUSED:
					$.videoMessage.setMessage( null );
					clearInterval($.videoControlBar.intervalID);
					$.videoControlBar.intervalID = 0 ;

					$.mediaPlayer.jMediaContainer.removeClass('isPlaying');
					break;
				default:
					break;
			}
		},

		afterVideoAction : function(keyCode)
		{
			switch(keyCode)
			{
				case $.key.KEY_PLAY:
					$.mediaPlayer.jMediaContainer.addClass('isPlaying');
					break;
				case $.key.KEY_STOP:
				case $.key.KEY_PAUSE:
					$.mediaPlayer.jMediaContainer.removeClass('isPlaying');
					break;
				case $.key.KEY_FULLSCREEN:

					if($.video.fullScreen)
					{
						$.mediaPlayer.jMediaContainer.addClass('fullScreen');
						setTimeout(function(){ $.videoMessage.setMessage( null ); }, 2500);

						if( $.videoMessage.testShowing() )
						{
							$.videoMessage.jMsg.css('left','' + ($.mediaPlayer.jMediaContainer.width() - $.videoMessage.jMsg.width())/2 + 'px');
						}
						else
						{
							$.videoMessage.setMessage("Press 0 to Exit Full Screen");
						}
					}
					else
					{
						$.mediaPlayer.jMediaContainer.removeClass('fullScreen');

						$.videoMessage.setMessage( null );
						$.videoMessage.jMsg.css('left','' + ($.mediaPlayer.jMediaContainer.width() - $.videoMessage.jMsg.width())/2 + 'px');
					}

					$.videoControlBar.setVisible( false );

					break;
				default:
					break;
			}
		},
		
		timeoutID : 0,
		setVisible : function( isVisible )
		{
			var jObj = $.mediaPlayer.jMediaContainer.find("#_videoControlBar");

			//jObj.stop().css('opacity','90').show();
			clearTimeout(this.timeoutID);
			jObj.show();

			if( isVisible ) return;
			if( $.video.getPlayState() != $.status.VIDEO_PLAYING ) return;
			if( ($.mediaPlayer.jMediaContainer.attr("class").indexOf("barOutside") >=0) && !$.video.fullScreen ) return;
			//jObj.fadeOut(5000);
			this.timeoutID = setTimeout("$.mediaPlayer.jMediaContainer.find('#_videoControlBar').hide();timeoutID = 0;",5000);
		},
		
		onNavKeyPress : function(keyCode)
		{
			if($.videoControlBar.isFocused())
			{
				switch(keyCode)
				{
					case $.key.KEY_LEFT: $.videoControlBar.handleLeft(); break;
					case $.key.KEY_RIGHT: $.videoControlBar.handleRight(); break;
					default:break;
				}
			}
			
			if($.video.getPlayState() != $.status.VIDEO_PLAYING) return;
			$.videoControlBar.setVisible( false );
		},
		
		////////// handle Navigate keys click
		
		handleFocusIn : function(){
			$.videoControlBar.handleRight();
		},
		handleFocusOut : null,
		focusTag : 0,
		
		handleLeft: function()
		{
			var firstFosucIndex = $.mediaPlayer.isRightAlign ? 0 : 2;
			switch( this.focusTag )
			{
			case 0:
				console.log("error");
				break;
			case 1:
				if($.video.fullScreen) return;
				$("#_videoControlBar >div:eq("+firstFosucIndex+")").blur();
				this.handleFocusOut();
				break;
			case 2:
				$("#_videoControlBar >div:eq("+firstFosucIndex+")").focus();
				break;
			case 3:
				$("#_videoControlBar >div:eq(1)").focus();
				break;
			default:
				break;
			}
			
			this.focusTag--;
		},
		
		handleRight: function()
		{
			if(this.focusTag < 3 && this.focusTag >= 0)
			{
				var focusObjIndex = $.mediaPlayer.isRightAlign ? this.focusTag : ( 2 - this.focusTag );
				$("#_videoControlBar >div:eq(" + focusObjIndex + ")").focus();

				this.focusTag++;
			}
		},
		
		isFocused: function()
		{
			return ($("#_videoControlBar >div.stop:focus").length == 1 ) || 
			($("#_videoControlBar >div.play:focus").length == 1 ) || 
			($("#_videoControlBar >div.fullScreen:focus").length == 1 ) ;
		}
	},

	$.videoMessage = 
	{
		jMsg : null,

		initMessage : function()
		{
			this.jMsg = $("<div id='_msg'><h2 id='_txt'></h2><div><img src='/apis/image/wait76x76.gif'></div></div>");
			$.mediaPlayer.jMediaContainer.append(this.jMsg);
		},

		setMessage : function(str)
		{
			if(typeof str == "undefined" || str == null || str == "") {
				this.jMsg.hide();
				return;
			}

			this.jMsg.find("#_txt").text(str);
			this.jMsg.css('left','' + ($.mediaPlayer.jMediaContainer.width() - this.jMsg.width())/2 + 'px' );

			this.jMsg.stop().css('opacity','100').show();
		},

		testShowing : function()
		{
			return ( this.jMsg.is(":visible") ) ;
		}
	},

	$.mediaPlayer = {
			
		jMediaContainer : null,
		isAudio : false,
		isRightAlign : false,
			
		initVideo : function(jParent, videotype, videosite, isBarInside )
		{
			if( $.mediaPlayer.isRightAlign )// Ҷ
			{
				$.key.KEY_LEFT = KEY_LEFT;
				$.key.KEY_RIGHT = KEY_RIGHT;
			}
			
			$.mediaPlayer.jMediaContainer = jParent;// ڵıǩλãṩ˸Ԫ
			jParent.addClass("videoContainer");
	
			if(videotype.indexOf("audio/") == 0)
			{
				$.mediaPlayer.isAudio = true;
				$.audio.initAudio(videotype, videosite );
				return;
			}
	
			$.mediaPlayer.isAudio = false;
	
			$.video.onNavKeyPress = $.videoControlBar.onNavKeyPress ;
			$.video.setVideoControlStatus = $.videoControlBar.setVideoControlStatus ;
			$.video.afterVideoAction = $.videoControlBar.afterVideoAction ;
	
			$.video.initVideo(videotype, videosite );
			$.videoControlBar.initVideoControlbar( isBarInside );
			$.videoMessage.initMessage();
			
			if(typeof __PORTAL_HOME__ != "undefined" && __PORTAL_HOME__.indexOf("portal.sparkonline.tv") >=0 )	// Add FullScreen @ footer
			{
				var fsHTML = "<div class='keyHelp'><img src='/apis/image/0.png'><H3>Full Screen</H3></div>";
				try{document.getElementById("helpKey2").innerHTML += fsHTML; } catch(e){}
			}
		},
	
		initVideoStatusCallback : function(callback)
		{
			$.mediaPlayer.isAudio ? ($.audio.statusCallback = callback) : ($.video.statusCallback = callback);
		},
	
		setVideoUrl : function( videoUrl )
		{
			$.mediaPlayer.isAudio ? $.audio.setVideoUrl( videoUrl ) : $.video.setVideoUrl( videoUrl );
		},
		
		controlVideo : function( controlStr )
		{
			var control = controlStr.toLowerCase();
			var e = new Object();
	
			if( control == "play" )
			{
				e.keyCode = $.key.KEY_PLAY;
			}
			else if( control == "pause" )
			{
				e.keyCode = $.key.KEY_PAUSE;
			}
			else if( control == "stop" )
			{
				e.keyCode = $.key.KEY_STOP;
			}
			else if( control == "fullscreen" )
			{
				e.keyCode = $.key.KEY_FULLSCREEN;
			}
	
			$.mediaPlayer.isAudio ? $.audio.audioControl( e ) : $.video.videoControl( e );
	
			return;
		},
		
		handleFocusIn : function()
		{
			$.videoControlBar.handleFocusIn();
		},
		
		handleFocusOut : function( callback )
		{
			$.videoControlBar.handleFocusOut = callback;
		},
		
		isMediaPlayerFocused: function()
		{
			return $.videoControlBar.isFocused();
		}
	};

})(jQuery);